// Copyright 2016 Pixar
//
// Licensed under the terms set forth in the LICENSE.txt file available at
// https://openusd.org/license.
//
// Modified by Jeremy Retailleau.

////////////////////////////////////////////////////////////////////////
// This file is generated by a script.  Do not edit directly.  Edit the
// wrapMatrix3.template.cpp file to make changes.

{% extends "wrapMatrix.template.cpp" %}

{% block customIncludes %}
#include <pxr/gf/quat{{ SCL[0] }}.h>
#include <pxr/gf/rotation.h>
{% endblock customIncludes %}

{% block customInit %}
        .def(init< const GfRotation& >())
        .def(init< const GfQuat{{ SCL[0] }}& >())
{% endblock customInit %}

{% block customDefs %}
        .def("GetHandedness", &This::GetHandedness)
        .def("IsLeftHanded", &This::IsLeftHanded)
        .def("IsRightHanded", &This::IsRightHanded)

        .def("Orthonormalize", &This::Orthonormalize,
             (arg("issueWarning") = true))
        .def("GetOrthonormalized", &This::GetOrthonormalized,
             (arg("issueWarning") = true))
{% endblock customDefs %}

{% block customXformDefs %}
        .def("SetScale", (This & (This::*)( const GfVec3{{ SCL[0] }} & ))&This::SetScale, return_self<>())
        .def("SetRotate",
             (This & (This::*)( const GfQuat{{ SCL[0] }} & )) &This::SetRotate,
             return_self<>())
        .def("SetRotate",
             (This & (This::*)( const GfRotation & )) &This::SetRotate,
             return_self<>())
        .def("ExtractRotation", &This::ExtractRotation)
        .def("SetScale", (This & (This::*)( {{ SCL }} ))&This::SetScale, return_self<>())

{% endblock customXformDefs %}
