// Copyright 2016 Pixar
//
// Licensed under the terms set forth in the LICENSE.txt file available at
// https://openusd.org/license.
//
// Modified by Jeremy Retailleau.

////////////////////////////////////////////////////////////////////////
// This file is generated by a script.  Do not edit directly.  Edit the
// vec.template.cpp file to make changes.

#include "./vec2h.h"

#include "./math.h"
#include "./ostreamHelpers.h"
#include <pxr/tf/type.h>

// Include headers for other vec types to support wrapping conversions and
// operators.
#include "./vec2d.h"
#include "./vec2f.h"
#include "./vec2i.h"

#include <vector>
#include <ostream>

namespace pxr {

TF_REGISTRY_FUNCTION(pxr::TfType) {
    TfType::Define<GfVec2h>();
}

std::ostream& 
operator<<(std::ostream &out, GfVec2h const &v)
{
    return out << '(' 
        << Gf_OstreamHelperP(v[0]) << ", " 
        << Gf_OstreamHelperP(v[1]) << ')';
}


bool
GfVec2h::operator==(GfVec2d const &other) const
{
    return _data[0] == other[0] &&
           _data[1] == other[1];
}
bool
GfVec2h::operator==(GfVec2f const &other) const
{
    return _data[0] == other[0] &&
           _data[1] == other[1];
}
bool
GfVec2h::operator==(GfVec2i const &other) const
{
    return _data[0] == other[0] &&
           _data[1] == other[1];
}


}  // namespace pxr
